/* mod_gss.h.  Generated from mod_gss.h.in by configure.  */
/* mod_gss.h.in.  Generated from configure.in by autoheader.  */

/*
 * mod_gss - an RFC2228 GSSAPI module for ProFTPD
 *
 * Copyright (c) 2002-2007 M Moeller <markus_moeller@compuserve.com>
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 *
 * As a special exemption, M Moeller gives permission to link this program
 * with MIT, Heimdal or other GSS/Kerberos libraries, and distribute
 * the resulting executable, without including the source code for
 * the Libraries in the source distribution.
 *
 */


/* Define to 1 if you have the <com_err.h> header file. */
/* #undef HAVE_COM_ERR_H */

/* Define gss_int32 */
/* #undef HAVE_GSS_INT32 */

/* Define Heimdal Kerberos */
/* #undef HAVE_HEIMDAL_KERBEROS */

/* Define krb5_get_init_creds_password */
#define HAVE_INIT_CREDS_PASSWORD 1

/* Define krb5_get_init_creds_password */
/* #undef HAVE_INIT_CREDS_PASSWORD_UNUSED */

/* Define to 1 if you have the <inttypes.h> header file. */
/* #undef HAVE_INTTYPES_H */

/* Define to 1 if you have the <krb5.h> header file. */
/* #undef HAVE_KRB5_H */

/* Define to 1 if you have the <memory.h> header file. */
/* #undef HAVE_MEMORY_H */

/* Whether the MEMORY:-keytab is supported */
/* #undef HAVE_MEMORY_KEYTAB */

/* Define NAS Kerberos */
/* #undef HAVE_NAS_KERBEROS */

/* Define SEAM Kerberos */
/* #undef HAVE_SEAM_KERBEROS */

/* Define to 1 if you have the <stdint.h> header file. */
/* #undef HAVE_STDINT_H */

/* Define to 1 if you have the <stdlib.h> header file. */
/* #undef HAVE_STDLIB_H */

/* Define to 1 if you have the <strings.h> header file. */
/* #undef HAVE_STRINGS_H */

/* Define to 1 if you have the <string.h> header file. */
/* #undef HAVE_STRING_H */

/* Define to 1 if you have the <sys/stat.h> header file. */
/* #undef HAVE_SYS_STAT_H */

/* Define to 1 if you have the <sys/types.h> header file. */
/* #undef HAVE_SYS_TYPES_H */

/* Define to 1 if you have the <unistd.h> header file. */
/* #undef HAVE_UNISTD_H */

/* Define to 1 if you have the `unsetenv' function. */
#define HAVE_UNSETENV 1

/* Define __gss_userok */
/* #undef HAVE___GSS_USEROK */

/* Define to the address where bug reports for this package should be sent. */
#define PACKAGE_BUGREPORT "markus_moeller@compuserve.com"

/* Define to the full name of this package. */
#define PACKAGE_NAME "mod_gss"

/* Define to the full name and version of this package. */
#define PACKAGE_STRING "mod_gss 1.3.2"

/* Define to the one symbol short name of this package. */
#define PACKAGE_TARNAME "mod_gss"

/* Define to the version of this package. */
#define PACKAGE_VERSION "1.3.2"

/* The size of `int', as computed by sizeof. */
#define SIZEOF_INT 4

/* The size of `long', as computed by sizeof. */
#define SIZEOF_LONG 4

/* The size of `short', as computed by sizeof. */
#define SIZEOF_SHORT 2

/* Define to 1 if you have the ANSI C header files. */
/* #undef STDC_HEADERS */

#include "conf.h"
#include "privs.h"

/* Make sure the version of proftpd is as necessary. */
#if PROFTPD_VERSION_NUMBER < 0x0001030001
# error "ProFTPD 1.3.0rc1 or later required"
#endif

#ifdef HAVE_HEIMDAL_KERBEROS
#include <gssapi.h>
#include <krb5.h>
#define error_message(code) krb5_get_err_text(kc,code)
#define gss_nt_service_name GSS_C_NT_HOSTBASED_SERVICE
#define gss_int32 int32_t
#else
#ifdef HAVE_SEAM_KERBEROS
#include <gssapi/gssapi.h>
#include <gssapi/gssapi_ext.h>
#define gss_nt_service_name GSS_C_NT_HOSTBASED_SERVICE
#ifndef HAVE_GSS_INT32
#define gss_int32 int32_t
#endif

#ifdef HAVE_KRB5_H
/* still testing this for OpenSolaris
Source includes are located in:
/usr/src/uts/common/gssapi/mechs/krb5/include/
and
/usr/src/lib/gss_mechs/mech_krb5/include
or
/usr/include/kerberosv5
*/
#include <krb5.h>
#ifdef HAVE_COM_ERR_H
#include <com_err.h>
#else
#if defined(__STDC__) || defined(__cplusplus) || defined(_MSDOS) || defined(_WIN32) || defined(macintosh)
#define ET_P(x) x
#else
#define ET_P(x) ()
#endif /* __STDC__ */
#ifndef KRB5_CALLCONV
#define KRB5_CALLCONV
#define KRB5_DLLIMP
#endif
#ifndef FAR
#define FAR
#endif
KRB5_DLLIMP extern const char FAR * KRB5_CALLCONV error_message ET_P((errcode_t));
#endif
#else
#ifndef HAVE___GSS_USEROK
/* Seam doesn't have krb5.h so define all here. Assume SEAM is based on MIT sources */
#define KRB5KDC_ERR_CLIENT_REVOKED               (-1765328366L)
#define KRB5KDC_ERR_C_PRINCIPAL_UNKNOWN          (-1765328378L)
#define KRB5KDC_ERR_PREAUTH_FAILED               (-1765328360L)

#if (SIZEOF_INT == 4)
typedef int             krb5_int32;
typedef unsigned int    krb5_ui_4;
#define VALID_INT_BITS    0x7fffffff
#define VALID_UINT_BITS   0xffffffff
#elif (SIZEOF_LONG == 4)
typedef long    krb5_int32;
typedef unsigned long   krb5_ui_4;
#elif (SIZEOF_SHORT == 4)
typedef short   krb5_int32;
typedef unsigned short  krb5_ui_4;
#else
 ?== error: undefined 32 bit type
#endif

typedef unsigned char   krb5_octet;
typedef unsigned int    krb5_boolean;

typedef krb5_int32      krb5_addrtype;
typedef krb5_int32      krb5_enctype;
typedef krb5_int32      krb5_authdatatype;
typedef krb5_int32      krb5_keyusage;
typedef krb5_int32      krb5_preauthtype;
typedef krb5_int32      krb5_flags;
typedef krb5_int32      krb5_timestamp;
typedef krb5_int32      krb5_error_code;
typedef krb5_int32      krb5_deltat;

typedef krb5_error_code krb5_magic;

struct  _krb5_context;
typedef struct _krb5_context *krb5_context;

typedef struct _krb5_data {
        krb5_magic magic;
        unsigned int length;
        char *data;
} krb5_data;

typedef struct krb5_principal_data {
    krb5_magic magic;
    krb5_data realm;
    krb5_data *data;            /* An array of strings */
    krb5_int32 length;
    krb5_int32 type;
} krb5_principal_data;

typedef krb5_principal_data *krb5_principal;

typedef struct _krb5_ticket_times {
    krb5_timestamp authtime;
    krb5_timestamp starttime;
    krb5_timestamp endtime;
    krb5_timestamp renew_till;
} krb5_ticket_times;

typedef struct _krb5_address {
    krb5_magic magic;
    krb5_addrtype addrtype;
    unsigned int length;
    krb5_octet *contents;
} krb5_address;

typedef struct _krb5_authdata {
    krb5_magic magic;
    krb5_authdatatype ad_type;
    unsigned int length;
    krb5_octet *contents;
} krb5_authdata;

typedef struct _krb5_get_init_creds_opt {
    krb5_flags flags;
    krb5_deltat tkt_life;
    krb5_deltat renew_life;
    int forwardable;
    int proxiable;
    krb5_enctype *etype_list;
    int etype_list_length;
    krb5_address **address_list;
    krb5_preauthtype *preauth_list;
    int preauth_list_length;
    krb5_data *salt;
} krb5_get_init_creds_opt;

typedef struct _krb5_prompt {
    char *prompt;
    int hidden;
    krb5_data *reply;
} krb5_prompt;

#ifndef KRB5_CONFIG__
#ifndef KRB5_CALLCONV
#define KRB5_CALLCONV
#define KRB5_CALLCONV_C
#endif /* !KRB5_CALLCONV */
#endif /* !KRB5_CONFIG__ */

typedef krb5_error_code (KRB5_CALLCONV *krb5_prompter_fct)(krb5_context context,
                                             void *data,
                                             const char *name,
                                             const char *banner,
                                             int num_prompts,
                                             krb5_prompt prompts[]);

char *error_message(long code);

#if defined(KRB5_NO_CONST) || (defined(__ultrix) && !defined(__GNUC__))
#define krb5_const
#else
#define krb5_const const
#endif

#if (defined(__STDC__) || defined(__cplusplus) || defined(_MSDOS) || defined(_WIN32) || defined(KRB5_PROVIDE_PROTOTYPES)) && !defined(KRB5_NO_PROTOTYPES)
#define KRB5_PROTOTYPE(x) x
#if defined(__STDC__) || defined(__cplusplus) || defined(HAVE_STDARG_H) || defined(_MSDOS) || defined(_WIN32)
#define KRB5_STDARG_P(x) x
#else
#define KRB5_STDARG_P(x) ()
#endif /* defined(__STDC__) || defined(__cplusplus) || defined(HAVE_STDARG_H) */
#else
#define KRB5_PROTOTYPE(x) ()
#define KRB5_STDARG_P(x) ()
#endif /* STDC or PROTOTYPES */

void KRB5_CALLCONV krb5_free_context 
        KRB5_PROTOTYPE((krb5_context));
void KRB5_CALLCONV krb5_free_principal
        KRB5_PROTOTYPE((krb5_context, krb5_principal ));

krb5_boolean KRB5_CALLCONV krb5_kuserok
        KRB5_PROTOTYPE((krb5_context,
                krb5_principal, const char *));

krb5_error_code KRB5_CALLCONV krb5_init_context
        KRB5_PROTOTYPE((krb5_context *));
krb5_error_code KRB5_CALLCONV krb5_timeofday
        KRB5_PROTOTYPE((krb5_context,
                   krb5_int32 * ));
krb5_error_code KRB5_CALLCONV krb5_parse_name
        KRB5_PROTOTYPE((krb5_context,
                   krb5_const char *,
                   krb5_principal * ));

#endif /*HAVE___GSS_USEROK */
#endif /*HAVE_KRB5_H */
#else /*MIT*/
#include <gssapi/gssapi.h>
#include <gssapi/gssapi_generic.h>
#include <gssapi/gssapi_krb5.h>
#ifdef HAVE_NAS_KERBEROS
#include <ibm_svc/krb5_svc.h>
const char *KRB5_CALLCONV error_message(long code) {
 char *msg=NULL;
 krb5_svc_get_msg(code,&msg);
 return msg;
}
#endif
#endif
#endif

#ifndef GSS_C_AF_INET6
#define GSS_C_AF_INET6 24
#endif

extern session_t session;
extern xaset_t *server_list;

#ifndef HAVE_UNSETENV
void unsetenv(char *env_name) {
  extern char **environ;
  char **cc;
  int l;
  l=strlen(env_name);
  for (cc=environ;*cc!=NULL;cc++) {
    if (strncmp(env_name,*cc,l)==0 && ((*cc)[l]=='='||(*cc)[l]=='\0')) break;
  } for (; *cc != NULL; cc++) *cc=cc[1];
}
#endif

/* gss module definitions and variables */

#define MOD_GSS_VERSION         PACKAGE_NAME"/"PACKAGE_VERSION
#define MOD_AUTH_GSS_VERSION    "mod_auth_gss/"PACKAGE_VERSION
#define C_FWCCC   "FWCCC"       /* FW support PORT/EPORT/PASV/EPASV in clear */

/* mod_gss session flags */
#define GSS_SESS_AUTH_OK                0x0001
#define GSS_SESS_ADAT_OK                0x0002
#define GSS_SESS_PBSZ_OK                0x0004
#define GSS_SESS_DATA_WRITE		0x0010
#define GSS_SESS_DATA_WRITE_OK		0x0020
#define GSS_SESS_DATA_READ_OK		0x0040
#define GSS_SESS_DISPATCH               0x0100
#define GSS_SESS_CCC                    0x0200
#define GSS_SESS_FWCCC                  0x0400
#define GSS_SESS_INT_SUP                0x1000
#define GSS_SESS_CONF_SUP               0x2000
#define GSS_AUTH_AUTHORITATIVE          0x4000

#define GSS_SESS_PROT_C                 0x0000
#define GSS_SESS_PROT_S                 0x0001
#define GSS_SESS_PROT_P                 0x0002
#define GSS_SESS_PROT_E                 0x0004

/* mod_gss option flags*/
#define GSS_OPT_ALLOW_CCC               0x0001
#define GSS_OPT_ALLOW_FW_CCC            0x0002
#define GSS_OPT_ALLOW_FW_NAT            0x0004
#define GSS_OPT_REQUIRE_SEQ_PROT        0x0010
#define GSS_OPT_REQUIRE_REP_PROT        0x0020


#ifndef GSS_C_AF_INET6
#define GSS_C_AF_INET6 24
#endif
